#include "colormap.h"
#include <image.h>

static int comp_color_priv(const void*,const void*);


int colormap_load(colormap self,char* name)
{
  int error=image_charger(self,name);
  if(error <0)
    return error;
  if(image_give_hauteur(self) !=  1)
    return -4;
  return 0;
}
bouleen colormap_move_to(colormap self, int i)
{
  static Point P={0,0};

  COORDX(P)=i;
  return image_move_to(self,&P);
}
void colormap_initialize(colormap self,int nb_colors)
{
  image_initialize(self,3,nb_colors,1);
}
int colormap_give_color_comp(colormap self,int i,int comp)
{
  static Point P={0,0};

  COORDX(P)=i;
  return image_get_comp(self,&P,comp);
}
colormap colormap_give_sorted(colormap self, int axis,int* sorted_axis)
{
  int i;
  int *pixel;
  int* tmp_color,*tmp;
  int nb_color=colormap_give_nb_color(self);
  double M2[3],M1[3],M0;
  int max_axis;
  double max_var,tmp_var;
  colormap sorted_map=FAIRE_colormap();
  bouleen greatest_axis_var = (axis==3);

  assert(axis >=0 && axis <=3);

  if(greatest_axis_var)
    {
      for(i=0;i<3;i++)
	M2[i]=M1[i]=0;
    }


  tmp=tmp_color =(int*)malloc(sizeof(int)*3*nb_color);
  
  colormap_begin(self);
  do
    {
      pixel=colormap_read_color(self);
      for(i=0;i<3;i++)
	{
	  *tmp=pixel[i];
	  if(greatest_axis_var)
	    {
	      M2[i]+= (*tmp)*(*tmp);
	      M1[i]+=(*tmp);
	    }
	  tmp++;
	}
    }
  while(colormap_next(self));
  if(greatest_axis_var)
    {
      max_var=(M2[0]-M1[0]*M1[0]/nb_color);      
      axis=0;
      for(i=1;i<3;i++)
	{
	  tmp_var=(M2[i]-M1[i]*M1[i]/nb_color);

	  if(tmp_var > max_var)
	    {
	      max_var = tmp_var;
	      axis=i;
	    }
	}
    }
  if(sorted_axis != NULL)
    *sorted_axis = axis;

  comp_color_priv(&axis,NULL);
  qsort((void*)tmp_color,nb_color,3*sizeof(int),comp_color_priv);

  colormap_initialize(sorted_map,nb_color);
  colormap_begin(sorted_map);
  i=0;
  do
    {
      colormap_write_color(sorted_map,tmp_color+i);
      i+=3;
    }
  while(colormap_next(sorted_map));
  free(tmp_color);

  return sorted_map;
}
static int comp_color_priv(const void* col1,const void* col2)
{
  static int axis=0;
  int* color1=(int*)col1;
  int* color2=(int*)col2;

  if(col2==NULL)
    {
      axis=*color1;
      return 0;
    }
  if(color1[axis]<color2[axis])
    return -1;
  
  if(color1[axis]==color2[axis])
    return 0;

  return 1;
}
